////////////////////////////////////////
//
// Free for private and commercial use.
//
////////////////////////////////////////

// the flash loader saves here the user code entry address
#define PTR_USER_ENTRY	((uint32_t rom*)0x0C)

// the boot loader entry point located on a fixed address
extern erom c_startup;

////////////////////////////////////////

// ASCII char values for some special keys used in the monitor
#define BACKSPACE	8	// Ctrl+H
#define CTRL_Q		17	// Ctrl+Q
#define CTRL_S		19	// Ctrl+S
#define ESC			27	// ESC
#define CTRL_C		3	// Ctrl+C
#define BELL		7	// Ctrl+G

// Various record types used in Hex files
#define DATA_RECORD				0x00
#define EOF_RECORD				0x01
#define EXT_SEG_ADDR_RECORD		0x02
#define START_SEG_ADDR_RECORD	0x03
#define EXT_LIN_ADDR_RECORD		0x04
#define START_LIN_ADDR_RECORD	0x05

// Various states of the hex file downloader function
#define LOADHEX_USERABORT		-1
#define LOADHEX_OK				0
#define WAITFOR_RECORDBEGIN		1
#define RECORDLENGTH			2
#define COMMENTFIELD			3
#define OFFSET					4
#define RECORDTYPE				5
#define DATAFIELD				6
#define SUMCHECK				7
#define EXT_LIN_ADDR_FIELD		8

////////////////////////////////////////

int8_t LoadHexMain(uint32_t* puLinesInFile, uint32_t* puTotalBytes, uint32_t* puConflictAddr, uint32_t* puNotWritable, uint32_t* puDownLoadErrors);
